Ruby - Bug #12485

Kernel.Rational raises TypeError though given denominator returns 1 by to_int

06/13/2016 02:39 PM - mrkn (Kenta Murata)

Status: Closed
Priority: Normal
Assignee: mrkn (Kenta Murata)

Target version:

ruby -v: ruby 2.3.1p112 (2016-04-26 revision
54768) [x86_64-darwini15]

Backport:

2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:
UNKNOWN

Description
Is it an intentional behavior?

class << (o = Object.new)
def to_int
1
end
end

Rational (1, o) #=> TypeError: not an integer

Associated revisions

Revision d23d5¢3130a0944e7e591370cbf8599009318a7c - 10/22/2020 08:59 AM - Kenta Murata

rational.c: try converting by to_int in Rational() (#3684)
Revision d23d5c31 - 10/22/2020 08:59 AM - Kenta Murata
rational.c: try converting by to_int in Rational() (#3684)
History

#1 - 06/13/2016 02:53 PM - mrkn (Kenta Murata)
- File rational.c.diff added

Attached patch can fix this issue.

#2 - 06/13/2016 02:58 PM - nobu (Nobuyoshi Nakada)
You can use RB_INTEGER_TYPE_P in the trunk.

#3 - 06/13/2016 03:43 PM - mrkn (Kenta Murata)

Nobuyoshi Nakada wrote:

You can use RB_INTEGER_TYPE_P in the trunk.

| forgot it. Thanks.

#4 - 07/25/2019 03:29 PM - jeremyevans0 (Jeremy Evans)

- File rational-denom-to_int.patch added

I'm not sure if this is considered a bug or not. Rational will already try to convert numerator and denominator via to_r. However, if we do want to
convert via to_int if to_r is not defined, the attached patch should implement it.

#5 - 10/22/2020 06:12 AM - mrkn (Kenta Murata)
- Status changed from Open to Assigned

- Assignee set to mrkn (Kenta Murata)

I'm working on this at https:/github.com/ruby/ruby/pull/3684

#6 - 10/22/2020 09:00 AM - Anonymous

- Status changed from Assigned to Closed

Applied in changeset git|d23d5¢3130a0944e7e591370cbf8599009318a7c.

rational.c: try converting by to_int in Rational() (#3684)
Files

rational.c.diff 539 Bytes 06/13/2016 mrkn (Kenta Murata)

rational-denom-to_int.patch 1.73 KB 07/25/2019 jeremyevans0 (Jeremy Evans)
07/17/2025 22


https://github.com/ruby/ruby/pull/3684
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/d23d5c3130a0944e7e591370cbf8599009318a7c
https://bugs.ruby-lang.org/issues/3684
https://bugs.ruby-lang.org/issues/12485
http://www.tcpdf.org

